function [Znew dZdT]=DranchukPurvisRobinson(Tpr,p_pr)
global gas;
% the Z function presented in Mattar and Aziz's et.al paper concerning
% compressibility of natural gases. Function is derived by Dranchuk, Parvis
% and Robinson, and is a method based on BWR equation and adapted to fit
% the Standing-Katz curve
dZdT_pr=0;
    
A=[0.31506237;-1.04670990;-0.57832729;...
    0.53530771;-0.61232032;-0.10488813;...
    0.68157001;0.68446549];
Zold=1;
iter=1;
error=inf;
while error>1e-5
    pr=0.27*p_pr/(Zold*Tpr);
    Znew=1+(A(1)+A(2)/Tpr+A(3)/Tpr^3)*pr+(A(4)+A(5)/Tpr)*pr^2+A(5)*A(6)*pr^5/Tpr+...
        (A(7)*pr^2/Tpr^3)*(1+A(8)*pr^2)*exp(-A(8)*pr^2);
    error=abs(Znew-Zold);
    Zold=Znew;
    if iter>50
        Znew=compressibilityfactor(p_pr,Tpr);
        disp('no valid solution, using old method to calc Z')
        break
    end
    iter=iter+1;
    dZdrho_r=(A(1)+A(2)/T_pr+A(3)/T_pr^3)+2*(A(4)+A(5)/T_pr)*pr+5*A(5)*A(6)*pr^4/T_pr+...
    (2*A(7)*pr/T_pr^3)*(1+A(8)*pr^2-A(8)^2*pr^2)*exp(-A(8)*pr^2);
    drho_rdT_pr=-0.27*p_pr/(Z*T-pr^2);
    dZdT_pr=dZdrho_r*drho_rdT_pr;
%     drho_rdT_pr=-(0.27*p_pr/T_pr*(1/dZdT_pr)+0.27/Z*(p_pr/T_pr^2));
%     dZdT_pr=dZdrho_r*drho_rdT_pr;

end

 Zderivative(Tpr,pr,Znew)

% Z=Znew;
% dZdpr=(A(1)+A(2)/Tpr+A(3)/Tpr^3)+2*(A(4)+A(5)/Tpr)*pr+5*A(5)*A(6)*pr^4/Tpr+...
%     (2*A(7)*pr/Tpr^3)*(1+A(8)*pr^2-A(8)*pr^2)*exp(-A(8)*pr^2);
% 
% dZdTpr=-(A(2)*pr+A(5)*pr^2+A(5)*A(6)*pr^5)*Tpr^(-2)...
%     -3*(A(3)*pr+A(7)*pr^2*(1+A(8)*pr^2)*exp(-A(8)*pr^2))*Tpr^(-4);
% 
dT_prdT=1/gas.Tc;
dZdT=dZdT_pr*dT_prdT;
% 
% ddZddTpr=2*A(2)*pr/Tpr^3+12*A(3)*pr/Tpr^5+A(5)*pr^2/Tpr^3+A(5)*A(6)*pr^5/Tpr^3+...
%     12*(A(7)*pr^2*(1+A(8)*pr^2)*exp(-A(8)*pr^2))*Tpr^-5;
% ddZddT=ddZddTpr*dTprdT^2;
% % dZdT=0;
% Z=1;
% dZdT=0;
% dZdTpr=0;
end
