%   ******************************
%   * FRICTION FACTOR            *
%   ******************************

   
%***Colebrook***

function f=frictionfactor(M,gas,pipeline)


Re=gas.rho*(abs(M)/(gas.rho*pipeline.area))*pipeline.diameter/gas.my;

 if Re<2000 && Re>500
          f=64/Re;
     elseif Re<=500
          f=0.1;

     else    

    %---Colebrook----------
    % 1/f
        err=inf;
        tol_limit=1e-6;
        old_sqrtf=30;
        while err>tol_limit
            new_sqrtf=-2.0*log10((pipeline.roughness/pipeline.diameter)/3.7+2.51/Re*old_sqrtf);
            err=abs(new_sqrtf-old_sqrtf);
            old_sqrtf=new_sqrtf;
        end
        f=(1/new_sqrtf)^(2);
        %----------------------

end
 
%***Haalands equation***
%one_sqrtf=-1.8*log10(6.9/steady.re+((pipeline.roughness/pipeline.diameter)/3.7)^1.11);
%steady.f_haaland=(1/one_sqrtf)^(2);
%----------------------


