%   ******************************
%   * EVALUATION OF THE INERTIAL *
%   * MULTIPLIER                 *
%   ******************************

function alfa=inertial_multiplier(fi,inletbc,fluid,pipeline,gas,massflow_corr)

if inletbc.case==2
    delta_M=massflow_corr*0.5*((mean(inletbc.massflow)-min(inletbc.massflow))+(max(inletbc.massflow)-mean(inletbc.massflow)));
    oscill_period=input('oscillation period of massflow[min]: ');
    omega=1/(oscill_period*60)*2*pi;
    delta_q=delta_M/(massflow_corr*fluid.massflow(1));

elseif inletbc.case==3
    dM=input('Time derivative of massflow: ');
    delta_M=max(inletbc.massflow);
    omega=(pi/2)*dM/delta_M;
    delta_q=delta_M/fluid.massflow(1);
elseif inletbc.case==4
    dM=0.013;
    delta_M=(max(inletbc.massflow)-min(inletbc.massflow));
    omega=(pi/2)*dM/delta_M;
    delta_q=(pipeline.area/gas.wavespeed)*((max(fluid.pressure)-min(fluid.pressure))/fluid.massflow(1));
else
    disp('not a valid case for the inertial multiplier')
    quit;
end
h=pipeline.dx/pipeline.length;
m=fluid.massflow(1)/(gas.rho*pipeline.area)/gas.wavespeed;
friction=frictionfactor(fluid.massflow(1),gas,pipeline);
sigma=friction*pipeline.length/(2*pipeline.diameter);
p_d=sqrt(1-2*sigma*m^2);
omega_star=omega*pipeline.length/gas.wavespeed;

alfa=sqrt(1-(sigma*m*h)^2/(3*p_d)+fi*sqrt(p_d*(1+(sigma*m*omega_star)^2))/(m*omega_star*delta_q));
end