function []=findNewTemperature(fluid,previousA,Temperature)
global gas;
global pipeline;
% obtaining the rho cp term 
% Temperature=fluid.temperature(node);
avg.velocity=(fluid.velocity(node)+previousA.velocity(node-1))/2;
avg.density=(fluid.density(node)+previousA.density(node-1))/2;
avg.temperature=(fluid.temperature(node)+previousA.temperature(node-1))/2;
avg.lambda=frictionfactor(avg.velocity,avg.density,avg.temperature);

Temperature=(previousA.temperature(node-1)+Temperature)/2;
pressure=(fluid.pressure(node)+previousA.pressure(node-1))/2;
[cp, cv]=specificHeat(Temperature,pressure);
Tr=Temperature/gas.Tc;
pr=pressure/gas.pc;
Z=compressibilityfactor(pr,Tr);
%A=pressure*cp/(Z*gas.R);

% pressure and joule thomson term
[Zmattar dZdpr dZdT ddZddT]=mattarZfunction(Tr,pr);
B=(1+Temperature/Z*dZdT);

% Dissipation term

Dissipation=avg.density*avg.lambda*avg.velocity^2/(2*pipeline.diameter)*pipeline.dx;
% Dissipation=(fluid.density(node)+previousA.density(node-1))/2*
% averageVelocity=(fluid.flowrate(node)+previousA.flowrate(node-1)/2)*....
%     Z*gas.R*Temperature/(pressure*pipeline.area);
% density=pressure/(gas.R*Z*Temperature);
% lambda=frictionfactor(averageVelocity,density,Temperature);
% gas.R/(2*pipeline.diameter*pipeline.area^2)*

% obtain avg value for the heat conduction
pipeSegment=ceil(node/(pipeline.nodesPrDx));
burial=pipeline.burialType(pipeSegment);
T_env=outsideTemperatures(burial); 
my=viscosity(avg.temperature,avg,density);
U_Wtot=overallHeatTransfer(avg.velocity,burial,avg.density,my,cp);
HeatTransferCoeff=4*U_Wtot*pipeline.dx/(pipeline.diameter*avg.velocity);






return