% function  [fluid previousA]=newEnergyEqSolved2(fluid,previousA,temperature)
function  [dZdT_tmp]=newEnergyEqSolved2(fluid,previousA,temperature)
global K;
global gas;
global pipeline;
fluid.temperature(1)=interp1(linspace(1,length(temperature.in),...
    length(temperature.in)),temperature.in,1+temperature.readingPrMin*fluid.time/60)+K;
deltaTime=fluid.time-previousA.time;
% TmpTemperature=K:1:40+K;
for i=2:pipeline.nodes
%     for j=1:numel(TmpTemperature)
%         T_tmp=TmpTemperature(j);

        % for i=2
    pipeSegment=ceil(i/(pipeline.nodesPrDx));
    burial=pipeline.burialType(pipeSegment);
    T_env=outsideTemperatures(burial); 
    
    [cp_old, cv_old]=specificHeat(previousA.temperature(i-1),previousA.pressure(i-1));
    my_o=viscosity(previousA.temperature(i-1),previousA.density(i-1));
    oldU_Wtot=overallHeatTransfer(previousA.velocity(i-1),burial,...
        previousA.density(i-1),my_o,cp_old);
    fold=frictionfactor(previousA.velocity(i-1),previousA.density(i-1),previousA.temperature(i-1));
    DissipationA=previousA.density(i-1)*fold*previousA.velocity(i-1)^3*...
        previousA.time/(2*pipeline.diameter);

    HT.A=4*oldU_Wtot*previousA.time/pipeline.diameter;
    conv.A=(previousA.pressure(i-1)*cp_old/(previousA.Z(i-1)*gas.R));
    Tpr=previousA.temperature(i-1)/gas.Tc;
    p_pr=previousA.pressure(i-1)/gas.pc;
    [Zmattar dZdpr dZdT]=mattarZfunction(Tpr,p_pr);
    JT.old=(previousA.temperature(i-1)/previousA.Z(i-1))*(dZdT);
%     JT.old=0;
%       error=inf;
%     T_tmp=fluid.temperature(i);
%     j=1;
%     while error>1e-5
%         [cp_new, cv_new]=specificHeat(T_tmp,fluid.pressure(i));
%         my_n=viscosity(T_tmp,fluid.density(i));
%         
%         newU_Wtot=overallHeatTransfer(fluid.velocity(i),burial,...
%             fluid.density(i),my_n,cp_new);
%         fnew=frictionfactor(fluid.velocity(i),fluid.density(i),T_tmp);
%         DissipationP=fluid.density(i)*fnew*fluid.velocity(i)^3*...
%             fluid.time/(2*pipeline.diameter);
%         
%         Tpr=T_tmp/gas.Tc;
%         p_pr=fluid.pressure(i)/gas.pc;
%         Z=compressibilityfactor(p_pr,Tpr);
%         [Zmattar dZdpr dZdT ddZddT]=mattarZfunction(Tpr,p_pr);     
%         conv.P=(cp_new*fluid.pressure(i)/(Z*gas.R));
%         JT.new(i)=(T_tmp/Z)*dZdT;
%         jtcoeff(i)=1/(cp_new*fluid.density(i))*(T_tmp/Z)*dZdT;
%         
%         convection(i-1,j)=conv.P*log(T_tmp)-conv.A*log(previousA.temperature(i-1));
%         p_and_jt(i-1,j)=-(1+JT.new(i))*fluid.pressure(i)+(1+JT.old)*previousA.pressure(i-1);
%         Dissipation(i-1,j)=-DissipationP+DissipationA;
%         heatTrans(i-1,j)=(4*newU_Wtot/pipeline.diameter)*(T_tmp-T_env)*fluid.time-...
%             (4*oldU_Wtot/pipeline.diameter)*(previousA.temperature(i-1)-...
%             T_env)*previousA.time;
%         func(i-1,j)=convection(i-1,j)+p_and_jt(i-1,j)+Dissipation(i-1,j)+heatTrans(i-1,j);
% 
%         deriva(i-1,j)=(fluid.pressure(i)*cp_new/Z/gas.R)*(1/T_tmp)-...
%             (1+JT.new(i))*fluid.pressure(i)-(2*gas.R/(pi*pipeline.diameter^3))*...
%             (fnew*Z*fluid.flowrate(i)^2/fluid.pressure(i))+...
%             4*newU_Wtot/pipeline.diameter*fluid.time;
%         residual(i-1,j)=func(i-1,j)./deriva(i-1,j);
%         Tnew=T_tmp-func(i-1,j)./deriva(i-1,j);
% %         dissipDerivative(i-1)=-(2*gas.R/(pi*pipeline.diameter^3))*...
% %             (fnew*Z*fluid.flowrate(i)^2/fluid.pressure(i));
%         TemperatureMatrix(i-1,j)=Tnew;
%         error=abs(Tnew-T_tmp);
%         T_tmp=Tnew;
%         if j==200
%             break
%         end
%         j=j+1;
%     end

%   error=inf;
%     iter=1;
% 
%       while error>1e-5
%         Tnew(1,iter)=fluid.temperature(1);
%           
%         [cp_new, cv_new]=specificHeat(T_tmp,fluid.pressure(i));
%         my_n=viscosity(T_tmp,fluid.density(i));
%         conv.P=(cp_new*fluid.pressure(i)/(fluid.Z(i)*gas.R));
%         newU_Wtot=overallHeatTransfer(fluid.velocity(i),burial,...
%             fluid.density(i),my_n,cp_new);
%         fnew=frictionfactor(fluid.velocity(i),fluid.density(i),T_tmp);
%         DissipationP=fluid.density(i)*fnew*fluid.velocity(i)^3*...
%             fluid.time/(2*pipeline.diameter);
%         
% %         DissipationP=0;
%         Tpr=T_tmp/gas.Tc;
%         p_pr=fluid.pressure(i)/gas.pc;
%         Z=compressibilityfactor(p_pr,Tpr);
%         [Zmattar dZdpr dZdT_tmp(i) ddZddT]=mattarZfunction(Tpr,p_pr);
%         dZdT=dZdT_tmp(i);
%         JT.new=(T_tmp/fluid.Z(i))*dZdT;
% %         JT.new=0;
% %         HT.P=4*newU_Wtot*fluid.time/pipeline.diameter;
%         conv.P=cp_new*fluid.pressure(i)/(Z*gas.R);
%         convection(i-1,iter)=conv.P*log(T_tmp)-conv.A*log(previousA.temperature(i-1));
%         P_JT=-((1+JT.new)*fluid.pressure(i)-(1+JT.old)*previousA.pressure(i-1));
%         dissipation=-DissipationP+DissipationA;
%         U_Wavg=(newU_Wtot+oldU_Wtot)/2;
%         HeatTransfer=(4*U_Wavg/pipeline.diameter)*(0.5*(T_tmp+...
%             previousA.temperature(i-1))-T_env)*deltaTime;
%         tmp_function=convection+P_JT+dissipation+HeatTransfer;
%         F_Tp=@(T_p)conv.P*log(T_p)-conv.A*log(previousA.temperature(i-1))...
%             -((1+JT.new)*fluid.pressure(i)-(1+JT.old)*previousA.pressure(i-1))...
%             -DissipationP+DissipationA...
%             +(4*U_Wavg/pipeline.diameter)*(0.5*(T_tmp+...
%             previousA.temperature(i-1))-T_env)*deltaTime;
%         Tnew(i,iter)=fzero(F_Tp,T_tmp);
% %         
% %         HeatTransfer=(HT.P*(T_tmp-T_env)-...
% %             (HT.A)*(previousA.temperature(i-1)-T_env));
% %         f_Tp=(convectiveTermP*log(T_tmp)-convectiveTermA*log(previousA.temperature(i-1))...
% %             -(1+JT_new)*fluid.pressure(i)+(1+JT_old)*previousA.pressure(i-1)...
% %             -(DissipationP-DissipationA)+HeatTransferP*(T_tmp-T_env)-...
% %             HeatTransferA*(previousA.temperature(i-1)-T_env));
% %         df_TpdTp=(convectiveTermP*(1/T_tmp)-T_tmp/fluid.Z(i)...
% %             *dZdT+HeatTransferP);
% %         derivative=(fluid.pressure(i)*cp_new/gas.R)*(1/T_tmp)-fluid.pressure(i)/Z*...
% %             dZdT+(4*newU_Wtot*fluid.time/pipeline.diameter);
% %         Tnew=T_tmp-(convectiveTermP*log(T_tmp)-convectiveTermA*log(previousA.temperature(i-1))...
% %             -(1+JT_new)*fluid.pressure(i)+(1+JT_old)*previousA.pressure(i-1)...
% %             -(DissipationP-DissipationA)+HeatTransferP*(T_tmp-T_env)-...
% %             HeatTransferA*(previousA.temperature(i-1)-T_env))/...
% %             (convectiveTermP*(1/T_tmp)-fluid.pressure(i)/fluid.Z(i)...
% %             *dZdT+HeatTransferP);
% %         Tnew=T_tmp-(convection+P_JT*dissipation*HeatTransfer)/derivative;
%         
%          error=abs(Tnew(i,iter)-T_tmp);
%          T_tmp=Tnew(i-1,iter);
%         if iter>3
% 
% %              disp('no convergence')
%             break
%         end
% 
%         iter=iter+1;
%       end
%     fluid.temperature(i)=Tnew;
%     A0(i-1)=T_tmp;
% A(i-1)=conv.P*log(T_tmp)-conv.A*log(previousA.temperature(i-1));
% B(i-1)=((1+JT.new)*fluid.pressure(i)-(1+JT.old)*previousA.pressure(i-1));
% C(i-1)=HeatTransfer;

% B=0;
% B(i-1)=cp_old;
%     JT.new(i-1)=JT.new;
%     JT.old(i-1)=JT.old;
% fluid.temperature(i)=Tnew;

end
%  figure(8)
% plot(fluid.temperature-K);
% plot(fluid.temperature-previousA.temperature)
 previousA=fluid;
%  plot(fluid.pressure(2:end)-previousA.pressure(1:end-1))
 
% 
% subplot(221)
% plot(convT)
% subplot(222)
% plot(JTpart)
% subplot(223)
% plot(dissip)
% subplot(224)
% plot(HeatTrans)
end