function []=temperatureSolve(fluid,previousA,node)
node
global pipeline;
global gas;

% TemperatureScale=max(fluid.temperature)+1:-0.1:min(fluid.temperature)-1;
% TemeperatureScale=linspace(max(fluid.temperature),min(fluid.temperature),
% pipeline.nodes);

pipeSegment=ceil(node/(pipeline.nodesPrDx));
burial=pipeline.burialType(pipeSegment);
T_env=outsideTemperatures(burial); 

[cp_old, ~]=specificHeat(previousA.temperature(node-1),previousA.pressure(node-1));
my_o=viscosity(previousA.temperature(node-1),previousA.density(node-1));
oldU_Wtot=overallHeatTransfer(previousA.velocity(node-1),burial,...
    previousA.density(node-1),my_o,cp_old);
fold=frictionfactor(previousA.velocity(node-1),previousA.density(node-1),...
    previousA.temperature(node-1));
Tpr=previousA.temperature(node-1)/gas.Tc;
p_pr=previousA.pressure(node-1)/gas.pc;
[~ , ~, dZdT]=mattarZfunction(Tpr,p_pr);

nodeA.dissipation=previousA.density(node-1)*fold*previousA.velocity(node-1)^3*...
    previousA.time/(2*pipeline.diameter);
nodeA.convection=(previousA.pressure(node-1)*cp_old/(previousA.Z(node-1)...
    *gas.R))*log(previousA.temperature(node-1));
nodeA.heatTransfer=(4*oldU_Wtot*previousA.time/pipeline.diameter)*...
    (previousA.temperature(node-1)-T_env);
nodeA.pressureTerm=(1+(previousA.temperature(node-1)/previousA.Z(node-1))*(dZdT))...
    *previousA.pressure(node-1);
T_tmp=fluid.temperature(node);
[old_sign sum_func]=computeSumFuncTP(nodeA,fluid,node,T_env,burial,T_tmp);
if abs(sum_func)>1;
% old_sign=sign(sum_func);
%     [cp_new, ~]=specificHeat(T_tmp,fluid.pressure(node)); 
%     my_n=viscosity(T_tmp,fluid.density(node));
%     newU_Wtot=overallHeatTransfer(fluid.velocity(node),burial,...
%         fluid.density(node),my_n,cp_new);
%     fnew=frictionfactor(fluid.velocity(node),fluid.density(node),T_tmp);
%     Tpr=T_tmp/gas.Tc;
%     p_pr=fluid.pressure(node)/gas.pc;
%     Z=compressibilityfactor(p_pr,Tpr);
%     [~, ~, dZdT,~]=mattarZfunction(Tpr,p_pr);       
%     disp('in ordinary code')
%     convection.P=(cp_new*fluid.pressure(node)/(Z*gas.R))*log(T_tmp);
% 
%     dissipation.P=fluid.density(node)*fnew*fluid.velocity(node)^3*...
%         fluid.time/(2*pipeline.diameter);
% 
%     heatTransfer.P=(4*newU_Wtot/pipeline.diameter)*(T_tmp-T_env)*fluid.time;
% 
% %     JT.P=(T_tmp/fluid.Z(node))*dZdT;
%     pressure_term.P=(1+(T_tmp/fluid.Z(node))*dZdT)*fluid.pressure(node);
% 
% 
%     sum_function=convection.P-convection.A-...
%         pressure_term.P+pressure_term.A-...
%         dissipation.P+dissipation.A+...
%         heatTransfer.P-heatTransfer.A
%     old_sign=sign(sum_function);

count=1;
status=0;
scaleMultiplier=2;
TemperatureScale=fluid.temperature(node)-2:0.1:fluid.temperature(node)+2;
middle=round(numel(TemperatureScale)/2);

% for ii=1:10
while status==0
    count
    if middle+count<=numel(TemperatureScale) && middle-count>0
        T_tmp1=TemperatureScale(middle-count);
        T_tmp2=TemperatureScale(middle+count);
%         break
    elseif node+count>numel(TemperatureScale) || node-count<=0
        disp('temperature out of scale, creating new Temperature scale')
%         break
        TemperatureScale=fluid.temperature(node)-2*scaleMultiplier...
            :0.1:fluid.temperature(node)+2*scaleMultiplier;
        scaleMultiplier=scaleMultiplier+1;
    end    
    
%     [cp_new, ~]=specificHeat(T_tmp,fluid.pressure(ii));
%     my_n=viscosity(T_tmp,fluid.density(ii));
%     newU_Wtot=overallHeatTransfer(fluid.velocity(ii),burial,...
%         fluid.density(ii),my_n,cp_new);
%     fnew=frictionfactor(fluid.velocity(ii),fluid.density(ii),T_tmp);
%     Tpr=T_tmp/gas.Tc;
%     p_pr=fluid.pressure(ii)/gas.pc;
%     Z=compressibilityfactor(p_pr,Tpr);
%     [~ , ~, dZdT, ~]=mattarZfunction(Tpr,p_pr);       
% 
%     convection.P=(cp_new*fluid.pressure(ii)/(Z*gas.R))*log(T_tmp);
%     dissipation.P=fluid.density(ii)*fnew*fluid.velocity(ii)^3*...
%         fluid.time/(2*pipeline.diameter);
%     heatTransfer.P=(4*newU_Wtot/pipeline.diameter)*(T_tmp-T_env)*fluid.time;
%     JT.P=(T_tmp/fluid.Z(ii))*dZdT;
%     pressure_term.P=(1+JT.P)*fluid.pressure(ii);
% 
%     sum_function=convection.P-convection.A-...
%         pressure_term.P+pressure_term.A-...
%         dissipation.P+dissipation.A+...
%         heatTransfer.P-heatTransfer.A;
    [sign1 sum_func1]=computeSumFuncTP(nodeA,fluid,node,T_env,burial,T_tmp1);
    [sign2 sum_func2]=computeSumFuncTP(nodeA,fluid,node,T_env,burial,T_tmp2);
    
    
%     sign1=sign(sum_func1);
%     sign2=sign(sum_func2);
%     
    if sign1~=old_sign
old_sign
        sign1
        
        disp('tralala')
        
        minTemp=TemperatureScale(middle-count)
        msxTemp=TemperatureScale(middle-count+1)
        break
        [T_tmp,sumFunc]=findTemperature(node,nodeA,fluid,T_env,burial,maxTemp,minTemp,sum_func1,old_sign,1);
        T_tmp
        status=1;
        
    elseif sign2~=old_sign
        T_tmp2
        old_sign
sign2
sum_func2
        disp('asdfasdfasdfan');
        
        minTemp=TemperatureScale(middle+count-1)
        maxTemp=TemperatureScale(middle+count)
%         maxTemp=T_tmp2;
        break
%         computeSumFuncTP(nodeA,fluid,node,T_env,burial,maxTemp);
%         computeSumFuncTP(nodeA,fluid,node,T_env,burial,minTemp);
        [T_tmp,sumFunc]=findTemperature(node,nodeA,fluid,T_env,burial,maxTemp,minTemp,sum_func2,old_sign,2);
        T_tmp


       status=1;
        
    else
        count=count+1;
    end  
    
end
end