function sum_function=testfunction(fluid,previousA,node,T_tmp)
global pipeline;
global gas;

pipeSegment=ceil(node/(pipeline.nodesPrDx));
burial=pipeline.burialType(pipeSegment);
T_env=outsideTemperatures(burial); 

[cp_old, cv_old]=specificHeat(previousA.temperature(node-1),previousA.pressure(node-1));
my_o=viscosity(previousA.temperature(node-1),previousA.density(node-1));
oldU_Wtot=overallHeatTransfer(previousA.velocity(node-1),burial,...
    previousA.density(node-1),my_o,cp_old);
fold=frictionfactor(previousA.velocity(node-1),previousA.density(node-1),previousA.temperature(node-1));
Tpr=previousA.temperature(node-1)/gas.Tc;
p_pr=previousA.pressure(node-1)/gas.pc;
[Zmattar dZdpr dZdT]=mattarZfunction(Tpr,p_pr);

dissipation.A=previousA.density(node-1)*fold*previousA.velocity(node-1)^3*...
    previousA.time/(2*pipeline.diameter);
heatTransfer.A=4*oldU_Wtot*previousA.time/pipeline.diameter;
convection.A=(previousA.pressure(node-1)*cp_old/(previousA.Z(node-1)*gas.R))*log(previousA.temperature(node-1));;
JT.A=(previousA.temperature(node-1)/previousA.Z(node-1))*(dZdT);
pressure_term.A=(1+JT.A)*previousA.pressure(node-1);

[cp_new, cv_new]=specificHeat(T_tmp,fluid.pressure(node));
my_n=viscosity(T_tmp,fluid.density(node));
newU_Wtot=overallHeatTransfer(fluid.velocity(node),burial,...
    fluid.density(node),my_n,cp_new);
fnew=frictionfactor(fluid.velocity(node),fluid.density(node),T_tmp);
Tpr=T_tmp/gas.Tc;
p_pr=fluid.pressure(node)/gas.pc;
Z=compressibilityfactor(p_pr,Tpr);
[Zmattar dZdpr dZdT ddZddT]=mattarZfunction(Tpr,p_pr);       

convection.P=(cp_new*fluid.pressure(node)/(Z*gas.R))*log(T_tmp);
dissipation.P=fluid.density(node)*fnew*fluid.velocity(node)^3*...
    fluid.time/(2*pipeline.diameter);
heatTransfer.P=(4*newU_Wtot/pipeline.diameter)*(T_tmp-T_env)*fluid.time;
JT.P=(T_tmp/fluid.Z(node))*dZdT;
pressure_term.P=(1+JT.P)*fluid.pressure(node);
convection.P-convection.A
-pressure_term.P+pressure_term.A
-dissipation.P+dissipation.A
heatTransfer.P-heatTransfer.A
sum_function=convection.P-convection.A-...
    pressure_term.P+pressure_term.A-...
    dissipation.P+dissipation.A+...
    heatTransfer.P-heatTransfer.A;
    

end
