function [T]=calcInitialTemperatureDistribution(temperature)
global xScale;
global pipeline;
global K;
global date;
global pipelinecase;
global nodeMultiplicationfactor;
% calculate a temperaturefunction of the form T(x)=Ae^bx
% A=temperature.in(1);
% b=(1/xScale(end))*log((temperature.out(1))/(temperature.in(1)));
% 
% T=A*exp(b*xScale);
% 
% T=T+K;
    if strcmp(pipelinecase,'coated')==1
        T=xlsread('initialTemperature_coated_case1.xls');
    elseif strcmp(pipelinecase,'buried')==1
        T=xlsread('initialTemperature_buried_case1.xls');
    elseif strcmp(pipelinecase,'exposed')==1
        T=xlsread('initialTemperature_exposed_case1.xls');
    else
        disp('no valid initial temperature distribution');
    end
% Tnew=ones(pipeline.nodes,1)*T(1);
% if strcmp(date,'04.02.2009')==1
    % use original temperaure
if strcmp(date,'04.02.2009')==0
%     newTemperatureVector=zeros(pipeline.nodes,1);
    inletDiff=temperature.in(1)+K-T(1);
    outletDiff=temperature.out(1)+K-T(end);
    temperatureDifference=linspace(inletDiff,outletDiff,pipeline.nodes)';
    newTemperatureVector=T+temperatureDifference;
    T=newTemperatureVector;
end
    
% T=Tnew;    

% nodeMultiplicationfactor=2;
if nodeMultiplicationfactor~=1
    tmpT=zeros((numel(T)-1)*nodeMultiplicationfactor+1,1);


    % itr=1;
    % factor=nodeMultiplicationfactor/2;
    % delta=1/nodeMultiplicationfactor;
    % for numIter=1:factor
    %     for ii=1:nodeMultiplicationfactor:numel(tmpT)   
    %         if ii==numel(tmpT)
    %             tmpT(ii)=T(end);
    %         else
    %             tmpT(ii)=T(itr);
    %             tmpT(ii+nodeMultiplicationfactor/factor)=0.5*(T(itr)+T(itr+1));
    %             itr=itr+1;
    %         end
    %     end
    % end

    delta=1/nodeMultiplicationfactor;

    tmpT(1)=T(1);
    itr1=1;
    for ii=1:numel(T)-1
    % for ii=45:46
        temperatureList=[T(ii) T(ii+1)];
        itr1=itr1+1;
        for jj=1:nodeMultiplicationfactor-1
    %         interp1([1 2],temperatureList,1+delta*jj)
            tmpT(itr1)=interp1([1 2],temperatureList,1+delta*jj);
            itr1=itr1+1;
        end    
        tmpT(itr1)=T(ii+1);
    end
    tmpT(end)=T(end);
    % plot(tmpT)


    T=tmpT;
end

% T=xlsread('initialTemperature.xlsx',A1:A306);
end