%   **********************************
%   * Obtaining the compressibility  *
%   * factor for the gas, using redu-*
%   * sed temperature and pressure   *
%   **********************************

%-------------------------------------
%   STANDING-KATZ COMPRESSIBILITY
%   FUNCTION
%-------------------------------------

function Z=compressibilityfactor(pr,Tr)
% Z=1;

coeff= [1.6643 -2.2114 -0.3647 1.4385;... 
    0.5222 -0.8511 -0.0364 1.0490;...
    0.1291 -0.2988  0.0007 0.9969;...
    0.0295 -0.0825  0.0009 0.9967;...
    -1.357 1.4942  4.6315 -4.7009;...
    0.1717 -0.3232 0.5869 0.1229;...
    0.0984 -0.2053 0.0621 0.8580;...
    0.0211 -0.0527 0.0127 0.9549;...
    -0.3278 0.4752 1.8223 -1.9036;...
    -0.2521 0.3871 1.6087 -1.6635;...
    -0.0284 0.0625 0.4714 -0.0011;...
    0.0041 0.0039 0.0607 0.7927];


if pr > 0.2 && pr <=1.2
    if Tr >1.05 && Tr<=1.2  
        A=coeff(1,1);
        B=coeff(1,2);
        C=coeff(1,3);
        D=coeff(1,4);
    elseif Tr >1.2 && Tr<=1.4
        A=coeff(2,1);
        B=coeff(2,2);
        C=coeff(2,3);
        D=coeff(2,4);
    elseif Tr >1.4 && Tr<=2.0
        A=coeff(3,1);
        B=coeff(3,2);
        C=coeff(3,3);
        D=coeff(3,4);
    elseif Tr >2.0 && Tr<=3.0
        A=coeff(4,1);
        B=coeff(4,2);
        C=coeff(4,3);
        D=coeff(4,4);
    else return
    end
elseif pr > 1.2 && pr <=2.8
    if Tr >1.05 && Tr<=1.2
        A=coeff(5,1);
        B=coeff(5,2);
        C=coeff(5,3);
        D=coeff(5,4);
    elseif Tr >1.2 && Tr<=1.4
        A=coeff(6,1);
        B=coeff(6,2);
        C=coeff(6,3);
        D=coeff(6,4);
    elseif Tr >1.4 && Tr<=2.0
        A=coeff(7,1);
        B=coeff(7,2);
        C=coeff(7,3);
        D=coeff(7,4);
    elseif Tr >2.0 && Tr<=3.0
        A=coeff(8,1);
        B=coeff(8,2);
        C=coeff(8,3);
        D=coeff(8,4);
    else return
    end
elseif pr > 2.8 && pr <=5.4
    if Tr >1.05 && Tr<=1.2
        A=coeff(9,1);
        B=coeff(9,2);
        C=coeff(9,3);
        D=coeff(9,4);
    elseif Tr >1.2 && Tr<=1.4
        A=coeff(10,1);
        B=coeff(10,2);
        C=coeff(10,3);
        D=coeff(10,4);
    elseif Tr >1.4 && Tr<=2.0
        A=coeff(11,1);
        B=coeff(11,2);
        C=coeff(11,3);
        D=coeff(11,4);
    elseif Tr >2.0 && Tr<=3.0
        A=coeff(12,1);
        B=coeff(12,2);
        C=coeff(12,3);
        D=coeff(12,4);
    else return
    end
elseif pr>5.4 && pr<15
    a=0.711;
    b=3.66;
    c=-1.447;
    d=-1.637;
    e=0.319;
    f=0.522;
    g=2.071;
else return
end
if pr<=5.4
   Z=pr*(A*Tr+B)+C*Tr+D;
elseif pr>5.4
    Z=pr*(a+b*Tr)^c+d/(e*Tr+f)+g;
end
   

%    Z=1;
end
