
function [fluid previousA]=enthalpySolver(fluid,previousA,temperature)
global pipeline;
% global gas;
% global xScale;
global K;
% newEnthalpy=zeros(1,pipeline.nodes);
% delta_time=fluid.time-previousA.time;
% previousA.temperature(1)
fluid.temperature(1)=interp1(linspace(1,length(temperature.in),...
    length(temperature.in)),temperature.in,1+temperature.readingPrMin*fluid.time/60)+K;
[~, cv]=specificHeat(fluid.temperature(1),fluid.pressure(1));
% fluid.temperature(1)
fluid.enthalpy(1)=(cv*fluid.temperature(1))+fluid.pressure(1)/fluid.density(1);
% fluid.enthalpy(1)
deltaTime=fluid.time-previousA.time;
for i=2:pipeline.nodes
    pipeSegment=ceil(i/(pipeline.nodesPrDx));
    burial=pipeline.burialType(pipeSegment);
    T_env=outsideTemperatures(burial); 
    
    U_avg=0.5*(fluid.velocity(i)+previousA.velocity(i-1));
    rho=0.5*(fluid.density(i)+previousA.density(i-1));
    avgPress=0.5*(fluid.pressure(i)+previousA.pressure(i-1));
%     [cp_old, ~]=specificHeat(previousA.temperature(i-1),previousA.pressure(i-1));
    error=inf;
    numIter=0;
    TmpEnthalpy=previousA.enthalpy(i);
%     newEnthalpy=previousA.enthalpy(i);
    newTemperature=fluid.temperature(i);

    
    while error>1e-5
%         disp('lalal')
        avgTemperature=0.5*(newTemperature+previousA.temperature(i-1));
        my=viscosity(avgTemperature,rho);
        frFact=frictionfactor(U_avg,rho,avgTemperature);
%         [cp_new, cv_new]=specificHeat(avgTemperature,fluid.pressure(i));
        [cp, cv]=specificHeat(avgTemperature,avgPress);
%         cv=0.5*(cv_old+cv_new);
%         cp=0.5*(cp_old+cp_new);
%         tempConst=frFact/2/pipeline.diameter;
        U_Wtot=overallHeatTransfer(U_avg,burial,rho,my,cp);

%         newEnthaply=TmpEnthalpy-(fluid.density(i)*TmpEnthalpy-...
%             previousA.density(i-1)*previousA.enthalpy(i-1)-fluid.pressure(i)+...
%             previousA.pressure(i-1)-(frFact/2/pipeline.diameter)*(...
%             fluid.density(i)*fluid.velocity(i)^3*fluid.time-...
%             previousA.density(i-1)*previousA.density(i-1)^3*previousA.time)+...
%             (4*U_Wtot/pipeline.diameter)*(fluid.temperature(i)*fluid.time-...
%             previousA.temperature(i-1)*previousA.time-T_env*(fluid.time-...
%             previousA.time)))/fluid.density(i);
        
      
%         newEnthaply=TmpEnthalpy-(TmpEnthalpy-...
%             previousA.enthalpy(i-1)-1/rho*(fluid.pressure(i)+...
%             previousA.pressure(i-1))-frFact*U_avg^3*deltaTime/(2*pipeline.diameter)+...
%             (4*U_Wtot/pipeline.diameter)*(fluid.temperature(i)*fluid.time-...
%             previousA.temperature(i-1)*previousA.time-T_env*(fluid.time-...
%             previousA.time)))/fluid.density(i);
        newEnthalpy=previousA.enthalpy(i-1)+1/rho*(fluid.pressure(i)-...
            previousA.pressure(i-1))+frFact*U_avg^3*deltaTime/(2*pipeline.diameter)...
            -4*U_Wtot/(pipeline.diameter*rho)*(avgTemperature-T_env)*deltaTime;


        error=abs(newEnthalpy-TmpEnthalpy);
        TmpEnthalpy=newEnthalpy;
        if numIter>100
            fprintf('no convergence of enthalpy at node: %d\n',i); 
            break
        end
        newTemperature=1/cv*(newEnthalpy-fluid.pressure(i)/rho);
    end
%     fluid.enthalpy(i)=cv_new*newTemperature+fluid.pressure(i)/fluid.density(i);
    fluid.enthalpy(i)=newEnthalpy;
    fluid.temperature(i)=newTemperature;
    
end


% 
% plot(fluid.temperature-K)

% previousA.enthalpy(1)-fluid.enthalpy(1)
% 
% previousA.enthalpy(2)-fluid.enthalpy(2)

%     figure(3)
%     plot(fluid.temperature-previousA.temperature);

% plot(fluid.enthalpy,'r')
previousA=fluid;
% figure(7)
% plot(xScale,fluid.enthalpy,'k',xScale,newEnthalpy,'r')
% plot(xScale,fluid.temperature,'k');
% hold on
% a
% fluid.enthalpy=newEnthalpy;
% for ii=2:pipeline.nodes
%     internalEnergy=fluid.enthalpy(ii)-fluid.pressure(ii)/fluid.density(ii);
%     newTemperature=fluid.temperature(ii);
%     error=inf;
%     numIter=0;
%     TmpTemp=fluid.temperature(ii);
%     while error>1e-5
%         [cp, cv]=specificHeat(newTemperature,fluid.pressure(ii));
%         newTemperature=internalEnergy/cv;
%         error=abs(newTemperature-TmpTemp);
%         TmpTemp=newTemperature;
%         numIter=numIter+1;
%         if numIter>100
%             break
%         end
%     end
%     fluid.temperature(ii)=newTemperature;
%     
% end
% plot(xScale,fluid.temperature,'r');



end