function A=interpolate(B1,B2,time_calc,time_new,time_fluid,time_old)
%          P
%    o-----o-----o t_new
%         /|
%        / |
%       /  |
% B1 o-/---o-----o t_fluid
%     /    |
% A  x     |        t_calc
%          |
% B2 o-----o-----o t_old
% Since the characteristic is no longer constant, we must interplolate 
% in order to find the correct value at the given value in space
    if time_fluid-time_old==0
        A=B1;
    else
        timeEval=(time_new-time_calc-(time_new-time_fluid))/(time_fluid-time_old);
        A=B1-timeEval*(B1-B2);
    end
end
