% Calculation of the overall heat transfer coefficient

function U_Wtot=overallHeatTransfer(avgVelocity,burial,rho,my_gas,cp_gas)
global pipeline;
global pipelinecase;
% global gas;
%global flowCorr;
diameter.inner=1.00;        % pipeline inner diameter
if strcmp(pipelinecase,'coated')==1
    wallLayers=3;               % number of layers in coated pipeline    
    diameter.outer=1.160;       % pipeline outer diameter
    radius=[0.500;0.520;0.530;0.58];
    k_wall=[50;0.74;2.9];
    h_wall=0;
else 
    wallLayers=1;               
    diameter.outer=1.002;
    k_wall_single=100;
end
% diameter.outer=1.002;
%abientTemperature=5+273.15; % simplified ambient temperature 5 degrees Celcius

shallow_Dc=diameter.outer/2+0.001;                    % depth to centreline[m]
% shallow_Dc=0.75;
% controlDepth=(2*shallow_Dc/diameter.outer);
% if controlDepth<=1
%     shallow_Dc=1*diameter.outer/2;
% end
deep_Dc=1.0;
k_soil=2;                   % soil conductivity[W/mK]
if burial==1
%if strcmp('shallow',burialType)==1;
    % shallow burial of pipeline
    h_outer=(2*k_soil/diameter.outer)/log((2*shallow_Dc/diameter.outer)...
        +sqrt((2*shallow_Dc/diameter.outer)^2-1));  % shallow burial coefficient
elseif burial==2
% elseif strcmp('deep',burialType)==1
    % deep burial of pipeline
    h_outer=(2*k_soil/diameter.outer)/log(4*deep_Dc/diameter.outer);        % deep burial coefficient
elseif burial==3
%elseif strcmp('water',burialType)==1
    % if exposed to water
    U_sea=0.1;              % average sea velocity
    cp_sea=3985;            % specific heat[W*kg^-1*K^-1] 
    k_sea=0.563;            % thermal conductivit seawater[W*m^-1*K^-1]
%     k_sea=0.5;
    rho_sea=1030;           % sea water density[kg/m^3]
    my_sea=1.881e-3;        % sea water viscosit[N/m^2*s]
    
    Pr_sea=cp_sea*my_sea/k_sea;
    Re_sea=rho_sea*U_sea*diameter.outer/my_sea;
    Nu_sea=0.26*Re_sea^0.6*Pr_sea^0.3;
    h_outer=k_sea*Nu_sea/diameter.outer;                         % water burial coefficient
    
    % nusselt forced convection Klock thesis
%     Nu_sea_forced=0.3+0.62*Re_sea^0.5*Pr_sea^0.333/(1+(0.4/Pr_sea)^0.6667)^0.25*(1+(Re_sea/282000)^(5/8))^(4/5);
elseif burial==4
    %test exposure to air
    U_air=3.0;
    cp_air=1.0035;
    k_air=0.025;
    rho_air=1.250;
    my_air=16.625e-6;
    Pr_air=cp_air*my_air/k_air;
    Re_air=rho_air*U_air*diameter.outer/my_air;
    Nu_lam=0.664*Re_air^(1/2)*Pr_air^(1/3);
    Nu_turb=0.037*Re_air^0.8*Pr_air/(1+2.443*Re_air^-0.1*(Pr_air^(2/3)-1));
    Nu_air=0.3+sqrt(Nu_lam^2+Nu_turb^2);
%     Nu_air_test=0.0266*Re_air^0.805*Pr_air^(1/3)*(k_air/diameter.outer);
    %     Nu_air=0.26*Re_air^0.6*Pr_air^0.3;
    h_outer=k_air*Nu_air/diameter.outer;
end
% h_outer
% heat conduction through pipe wall
if wallLayers==1
    h_wall=log(diameter.outer/diameter.inner)/k_wall_single;
else
    for i=1:wallLayers
        h_wall=h_wall+log(radius(i+1)/radius(i))/k_wall(i);
    end
end
% h_wall

    % inner film coefficient
%    Cp_gas=1;                   % specific heat constant gas
%     my_gas=my;                  % gas viscosity
% k_gas=0.06 % value from paper by Prasad,Mani & Venart(1984)[W/mK]
    k_gas=0.030*1.7307;                    % gas conductivity
    Re_gas=rho*abs(avgVelocity)*diameter.inner/my_gas;
    Pr_gas=cp_gas*my_gas/k_gas;
    Nu_gas=0.23*Re_gas^0.8*Pr_gas^0.4;
    h_inner=Nu_gas*k_gas/diameter.inner;

% Overall heat transfer coefficient
U_Wtot=(1/h_inner+diameter.inner/2*h_wall+(diameter.inner)/(diameter.outer*h_outer))^(-1);

% (1/h_inner+diameter.inner/2*h_wall+(diameter.inner)/(diameter.outer*h_outer)*0+1/85.05)^-1;

if strcmp('coated',pipelinecase)==0 
    if burial==1
        U_Wtot=59.35;
    %     U_Wtot=6;
    elseif burial==2
        U_Wtot=1.94;
    elseif burial==3
        U_Wtot=79.05;
    end
% elseif pipelinecase==3
%         if burial==1
%         U_Wtot=59.35;
%     %     U_Wtot=6;
%     elseif burial==2
%         U_Wtot=1.94;
%     elseif burial==3
%         U_Wtot=79.05;
%     end
end
end