% function to calculate the heat capacity for the media under
% consideration, by Katz's Handbook of Natural Gas Engineering
% described in Langelandsvik`s thesis and used in TGNet.
function [cp cv]=specificHeat(T,p)
p=p/1e5;

global gas;
SG=gas.SG;  % SG: specific gravity
M=gas.MW;   % M: molecular weight
EXT=15.69e-02*p^1.106*exp(-6.203*T*1e-3)/SG;
cp=1.432*1e4-1.045*1e4*SG+3.255*T+10.01*SG*T+EXT;
cp=cp*0.16;
cvOvercp=1.0836-0.000115*T+(5.61-0.002*T)/M;
cv=cvOvercp*cp;
end