%   *****************************************
%   *CALCULATION OF THE VISCOSITYCOEFFICIENT*                      *
%   *****************************************

function my=viscosity(gas)
% first doing the calculation using Sutherlads power law

% data given for methan, CH$, which is approx 90% of the content of the
% natural gas
%     To=272.8;
%     myo=1.2018e-5;
%     S=197.78;
%     T=gas.T_init;

 % my=myo*(T/To)^(3/2)*(To+S)/(T+S)


%3rd attempt
T=gas.T_init*1.8;       % temperature in Rankine
rho=gas.rho/1000;       % gas density in g/cc
MW=gas.MW;              % molecular weight of gas
k1=9.379;
k2=0.016007;
k3=1.5;
k4=209.2;
k5=19.26;
x1=3.448;
x2=986.4;
x3=0.010009;
y1=2.447;
y2=0.2224;
X=x1+x2/T+x3*MW;
K=(k1+k2*MW)*T^k3/(k4+k5*MW+T);
Y=y1-y2*X;
my=10^(-4)*K*exp(X*rho^Y)*0.001;

end



